力扣HOT100之双指针:11. 盛最多水的容器

这道题用双指针法很快就做出来了,但是为什么我的双指针法在时间和空间上都不占优啊?

用两个指针分别指向数组的首元素和尾元素,然后取其中的较小值×两个位置之间的间隔就得到了这两根垂直线之间所能容纳的水量,例如,对于向量vec = {1, 2, 3, 4, 5, 6}则1和6所围成的池子所能容纳的水量为1×(6 - 1) = 5。然后两根指针不断向中间移动,用一个result变量来维护最大水量,问题来了,这两根指针向中间移动应当遵循什么规则呢?我们要知道,两根柱子之间的水量取决于较短的那个柱子,指针向中间移动的时候,水池的底部是不断变窄的,只有将最短的那根柱子拔高,才有可能增加蓄水量,尽管移动指向较短柱子的指针,可能新的柱子会更短,但是没有别的办法,不移动较短柱子一定不可能得到更大的蓄水量,所以我们需要判断左右指针指向的柱子中哪个较短,哪个较短就将哪个柱子向中间移动。

cpp 复制代码
class Solution {
public:
    int maxArea(vector<int>& height) {
        int result = 0;
        int left, right;
        for(left = 0, right = height.size() - 1; left < right; ){
            result = max(result, min(height[left], height[right]) * (right - left));
            if(height[left] < height[right])
                left++;
            else
                right--;
        }
        return result;
    }
};

但是感觉这个结果不是很满意啊?

看了下灵茶山大佬的题解,思路和我是一样的啊,怎么我的代码这么慢????

下面是灵神的代码

cpp 复制代码
class Solution {
public:
    int maxArea(vector<int>& height) {
        int ans = 0, left = 0, right = height.size() - 1;
        while (left < right) {
            int area = (right - left) * min(height[left], height[right]);
            ans = max(ans, area);
            height[left] < height[right] ? left++ : right--;
        }
        return ans;
    }
};

运行一下,发现和我的代码一样慢,绷不住了

看到灵神的代码和我一样慢我就放心了哈哈哈哈哈哈哈哈哈

相关推荐
dialect_1 小时前
KMP算法
开发语言·c++·算法
reikocao2 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
漂流瓶jz2 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
吞下星星的少年·-·3 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
文丑颜不良啊3 小时前
LeetCode1481~1500题目解析
java·leetcode
文丑颜不良啊3 小时前
LeetCode1381~1400题目解析
java·leetcode
是main不是漫4 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
深圳市快瞳科技有限公司5 小时前
野外鸟类AI识别落地实录:输入适配、结构化输出、去重聚合与置信度分流的工程实践
算法·计算机视觉·鸟类识别·鸟类ai识别·野外鸟类观测·林业调查
专注仿真6 小时前
梯度提升类(XFBoost)算法详解与代码实例
开发语言·人工智能·python·算法·大模型训练·控制算法
小豆庄7 小时前
视频遮罩追踪退场后ID撞号的排查—多目标场景下的失效
opencv·算法·bug·视频·python3.11